import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Bullets that Kirby must jump over.
 * 
 * @Jasmine Xiong
 * @May 29, 2019
 */
public class Bullets extends Actor
{
    int speed = 7;
    int animateTime = 0;

    public void act() 
    {
        move();
        remove();
        animate();
    }    
    
    // bullets move at constant speed
    public void move(){
        setLocation(getX()-speed, getY());
    }
    
    // removes bullets that are at the edge of the world
    public void remove(){
        if(getX() == 0){
            getWorld().removeObject(this);
        }
    }
    
    // i love animations
    public void animate(){
        animateTime++;
        if(animateTime == 15) setImage("bullet0.png");
        if(animateTime == 30) setImage("bullet1.png");
        if(animateTime == 45){
            setImage("bullet2.png");
            animateTime = 0;
        }
    }
}
