import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Enemies that charge at Kirby.
 * Can be killed if hit by fireball.
 * 
 * @Jasmine Xiong
 * @March 31, 2019
 */
public class Enemy extends Actor
{
    // enemies move at random speeds
    int speed = Greenfoot.getRandomNumber(3) + 2;
    int animateTime = 0;
    
    public void act() 
    {
        move();
        remove();
        animate();
    }    
    
    public void move(){
        // moving at random speeds!
        setLocation(getX() - speed, getY());
    }
    
    public void remove(){
        Fireball b = (Fireball)getOneIntersectingObject(Fireball.class);
        // if Enemy is at edge of is shot by fireball, remove Enemy
        if(isAtEdge() || b != null){
            getWorld().removeObject(b);
            getWorld().removeObject(this);
        }
    }
    
    public void animate(){
        animateTime++;
        if(animateTime == 5) setImage("enemy0.png");
        if(animateTime == 10) setImage("enemy1.png");
        if(animateTime == 15) setImage("enemy2.png");
        if(animateTime == 20) setImage("enemy3.png");
        if(animateTime == 25) setImage("enemy4.png");
        if(animateTime == 30) setImage("enemy5.png");
        if(animateTime == 35) setImage("enemy6.png");
        if(animateTime == 40) setImage("enemy7.png");
        if(animateTime == 45) setImage("enemy8.png");
        if(animateTime == 50) setImage("enemy9.png");
        if(animateTime == 55) setImage("enemy10.png");
        if(animateTime == 60) setImage("enemy11.png");
        if(animateTime == 65){
            setImage("enemy0.png");
            animateTime = 0;
        }
    }
}
