import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Kirby shoots these at enemies. (Enemies have not been added yet)
 * Timer needs to be added to prevent him from shooting too much in a row.
 * 
 * @Jasmine Xiong
 * @May 29, 2019
 */
public class Fireball extends Actor
{
    public Fireball(){
        // scaling the Fireball size
        GreenfootImage image = getImage();
        image.scale(image.getWidth() - 650, image.getHeight() - 650);
        setImage(image);
    }
    
    public void act() 
    {
        move();
        remove();
    }    
    
    public void remove(){
        // if Fireball is at edge of the world, remove Fireball
        if(isAtEdge()){
            getWorld().removeObject(this);
        }
    }
   
    public void move(){
        // Fireballs move at speed of 6
        setLocation(getX() + 6, getY());
    }
}
