import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Instructions page for Kirby Run!
 * Has Kirby and ground for you to figure out the controls before you begin the game.
 * Shortcut to boss battle is "B".
 * 
 * @Jasmine Xiong 
 * @June 12, 2019
 */
public class Instructions extends World
{
    
    public Instructions()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        GreenfootImage image = new GreenfootImage("backgroundthing.jpg");
        image.scale(image.getWidth()-450, image.getHeight()-200);
        setBackground(image);
        
        Ground g = new Ground();
        addObject(g, 300, 370);
        Kirby k = new Kirby();
        addObject(k, 100, 310);
        
        addObject(new Shortcut(), 400, 300);
    }
    
    public void act(){
        if(Greenfoot.isKeyDown("S")){
            Greenfoot.setWorld(new MyWorld());
        }
        
        // shortcut to boss battle
        if(Greenfoot.isKeyDown("B")){
            Greenfoot.setWorld(new Level3());
        }
    }
}
