import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Our HERO of this game!
 * This class controls Kirby's actions.
 * Jump, shoot, and collision detection features.
 * JUMPING IS FIXED :D
 * 
 * @Jasmine Xiong 
 * @May 28, 2019
 */
public class Kirby extends Actor
{    
    // jumping physics gravity variables
    // vspeed = vertical speed
    int vspeed = 0;
    int gravity = 1;
    
    // used to animate Kirby
    int animateTime = 0;
    
    // used to make sure Kirby doesn't constantly fire, that would make the game too easy
    int fireballTimer = 0;
    
    public void act() 
    {
        checkCollision();
        checkKeys();
        checkFall();
        animate();
        
        fireballTimer++;
    }    
    
    public boolean onGround(){
        Ground g = (Ground)getOneIntersectingObject(Ground.class);
        return g != null;
    }
    
    // checks if Kirby is hit by bullet or enemy
    // if he is hit, the game is over
    public void checkCollision(){
        Bullets b = (Bullets)getOneIntersectingObject(Bullets.class);
        if(b != null){
            Greenfoot.setWorld(new GameOver());
        }
        Enemy e = (Enemy)getOneIntersectingObject(Enemy.class);
        if(e != null){
            Greenfoot.setWorld(new GameOver());
        }
    }
    
    // controls!
    public void checkKeys(){
        // if the space bar is down and Kirby is on the ground, he can jump!
        if(Greenfoot.isKeyDown("space") && onGround()){
            jump();
            onGround();
        }
        // if the enter key is down and fireballTimer is greater than 30, he can shoot!
        if(Greenfoot.isKeyDown("enter") && fireballTimer > 30){
            getWorld().addObject(new Fireball(), 105, getY());
            fireballTimer = 0;
        }
    }
    
    public void checkFall(){
        if(onGround()){
            vspeed = 0;
        }
        else{
            fall();
        }
    }
    
    public void animate(){
        // sets Kirby shooting pose
        // a little sketchy :(
        String s = Greenfoot.getKey();
        if(s != null){
            if(s.equals("enter")){
                setImage("fire5.png");
            }
        }
        // otherwise animate Kirby running
        else{
            animateRun();
        }
    }
    
    public void animateRun(){
        animateTime++;
        if(animateTime == 5){
            setImage("run0.png");
        }
        if(animateTime == 10) setImage ("run1.png");
        if(animateTime == 15) setImage ("run2.png");
        if(animateTime == 20) setImage ("run3.png");
        if(animateTime == 25) setImage ("run4.png");
        if(animateTime == 30) setImage ("run5.png");
        if(animateTime == 35) setImage ("run6.png");
        if(animateTime == 40){
            setImage ("run7.png");
            animateTime = 0;
        }
    }
    
    // vspeed and fall used so that Kirby jumps smoothly
    public void jump(){
        vspeed = -18;
        fall();
    }
    
    public void fall(){
        setLocation(getX(), getY() + vspeed);
        vspeed = vspeed + gravity;
    }
}
