import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Second stage of Kirby Run. More enemies and faster bullets.
 * Essentially the same features as MyWorld (Level 1) except for background
 * and the rate of bullets and enemies spawn.
 * Kirby advances to the next level when the score hits 500.
 * 
 * @Jasmine Xiong
 * @June 4, 2019
 */
public class Level2 extends World
{
    int fireballTimer = 0;
    int cooldown = 50;
    public Level2(){    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        GreenfootImage image = new GreenfootImage("level2.jpg");
        image.scale(image.getWidth()+100, image.getHeight()+100);
        setBackground(image);
        
        Ground g = new Ground();
        addObject(g, 300, 370);
        Kirby k = new Kirby();
        addObject(k, 100, 310);
        
        Score2 score = new Score2();
        addObject(score, 70, 50);
    }
    
    public void act(){
        cooldown--;
        spawnBullets();
        spawnEnemies();
        fireballTimer++;
    }
    
    public void spawnEnemies(){
        if(Greenfoot.getRandomNumber(100) == 1){
            addObject(new Enemy(), 600, 300);
        }
    }
    
    public void spawnBullets(){
        if(Greenfoot.getRandomNumber(40)==1 && cooldown < 0){
            addObject(new Bullets(), 600, 300);
            cooldown = 50;
        }
    }
}
